#version 330

in vec4 position;
in vec3 normal;
in vec2 tex_coord;

uniform mat4 model_matrix;
uniform mat4 view_matrix;
uniform mat4 projection_matrix;

out vec3 VS_normal_ws;
out vec3 VS_position_ws;
out vec2 VS_tex_coord;

void main()
{
    VS_tex_coord = tex_coord;
    VS_position_ws = vec3(model_matrix * position);

    // We transform the normal using model_matrix, not the transpose of its inverse (the normal matrix).
    // This is correct as long as the transformation contains only translations and rotations.
    VS_normal_ws = normalize(mat3(model_matrix) * normal);

    gl_Position = projection_matrix * view_matrix * model_matrix * position;
}
